#ifndef CONSTANTS_H
#define CONSTANTS_H

#define NO_PLAYER 0
#define PLAYER_RED 1
#define PLAYER_BLUE 2

#define MATRIX_LEN 7
#define NR_BUTTONS 5
#define PASS_COUNTER 2000

#define LEFT_BUTTON 0
#define UP_BUTTON 1
#define DOWN_BUTTON 2
#define RIGHT_BUTTON 3
#define SELECT_BUTTON 4

#define VISITED 1
#define UNVISITED -1

char line_pins_red[MATRIX_LEN] = { PA6, PA5, PA4, PA3, PA2, PA1, PA0 };
char line_pins_blue[MATRIX_LEN] = { PC6, PC5, PC4, PC3, PC2, PC1, PC0 };
char col_ports[MATRIX_LEN] = { PB6, PB5, PB4, PB3, PB2, PB1, PB0 };
char button_ports[NR_BUTTONS] = { PD6, PD1, PD5, PD4, PD0 };

char game_matrix[MATRIX_LEN][MATRIX_LEN];
char visited[MATRIX_LEN * MATRIX_LEN];

int currentLine = 0;
int currentCol = 0;
int lineCounter = 0;
char light_flag = PLAYER_RED;

char button_state = -1;
char button_type = -1;

char player_red_pass = -1;
char player_blue_pass = -1;

char red_captures = 0;
char blue_captures = 0;

int counter = 0;
char turn = PLAYER_RED;
char winner = -1;

char red_winner[MATRIX_LEN][MATRIX_LEN] = {
  { NO_PLAYER, PLAYER_RED, PLAYER_RED, PLAYER_RED, PLAYER_RED, PLAYER_RED, NO_PLAYER },
  { NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_RED, NO_PLAYER},
  { NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER, NO_PLAYER, NO_PLAYER, NO_PLAYER},
  { NO_PLAYER, PLAYER_RED, PLAYER_RED, PLAYER_RED, PLAYER_RED, PLAYER_RED, NO_PLAYER},
  { NO_PLAYER, PLAYER_RED, NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER, NO_PLAYER},
  { NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER},
  { NO_PLAYER, PLAYER_RED, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_RED, NO_PLAYER}
};

char blue_winner[MATRIX_LEN][MATRIX_LEN] = {
  { NO_PLAYER, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, NO_PLAYER, NO_PLAYER },
  { NO_PLAYER, PLAYER_BLUE, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_BLUE, NO_PLAYER},
  { NO_PLAYER, PLAYER_BLUE, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_BLUE, NO_PLAYER},
  { NO_PLAYER, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, NO_PLAYER, NO_PLAYER},
  { NO_PLAYER, PLAYER_BLUE, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_BLUE, NO_PLAYER },
  { NO_PLAYER, PLAYER_BLUE, NO_PLAYER, NO_PLAYER, NO_PLAYER, PLAYER_BLUE, NO_PLAYER},
  { NO_PLAYER, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, PLAYER_BLUE, NO_PLAYER, NO_PLAYER},
};

#endif
